// Time functions

#include <time.h>
#include <stdio.h>
#include <string.h>

#include "ktime.h"

time_t gFanStartSeconds = 0 ;
int gFanTimerMode = 0 ;
time_t gFanStartTime = 0 ;
unsigned gFanRunInterval = 0 ;

static struct tm* getSystemDateTime ( void )
{
	time_t epochTime ;
	struct tm* brokenDownTimePtr ;
	
	// Get the system time - in epoch time form
	epochTime = time ( NULL ) ;
	
	// Break it down into components (hr, min, sec, etc.)
	brokenDownTimePtr = localtime ( &epochTime ) ;
	
	return brokenDownTimePtr ;
}

char* getFormattedDate ( void )
{
	static char formattedDate[100] ;
		
	( void ) strftime ( formattedDate, sizeof ( formattedDate ), "%F", getSystemDateTime ( ) ) ;
	
	return formattedDate ;
}

char* getFormattedTime ( void )
{
	static char formattedTime[100] ;
		
	( void ) strftime ( formattedTime, sizeof ( formattedTime ), "%T", getSystemDateTime ( ) ) ;
	
	return formattedTime ;
}

char* getFormattedDateTime ( void )
{
	static char formattedDateTime[200] ;
	
	strcpy ( formattedDateTime, getFormattedDate ( ) ) ;
	strcat ( formattedDateTime, "," ) ;
	strcat ( formattedDateTime, getFormattedTime ( ) ) ;
	
	return formattedDateTime ;
}

void startFanTimer ( int seconds )
{
	gFanTimerMode = 1 ;
	gFanRunInterval = seconds ;
	gFanStartTime = time ( NULL ) ;
}

// Returns 1 if fan should be stopped, 0 otherwise (fan
// is not running or timer has not expired)
int runFanTimer ( void )
{
	time_t timeNow ;
	
	if ( gFanTimerMode )
	{
		timeNow = time ( NULL ) ;
		if ( ( timeNow - gFanStartTime ) > gFanRunInterval ) 
		{
			stopFanTimer ( ) ;
			return 1 ;
		}
		
	}
	
	printf ( "In runFanTimer, mode=%d, timeNow = %lu, startTime = %lu\n",
		gFanTimerMode, timeNow, gFanStartTime ) ;
		
	return 0 ;
	
}

void stopFanTimer ( void )
{
	gFanTimerMode = 0 ;
}
/* 
void main ( int argc, char* argv[] )
{
	printf ( "Date = %s, Time = %s, DateTime = %s\n",
		getFormattedDate ( ),
		getFormattedTime ( ),
		getFormattedDateTime ( )
	) ;
	
	return ;
}
*/
